formInnerXDimension = 30;
formInnerYDimension = 76;
formInnerZDimension = 25;
formWallThickness = 2;
formScrewRadius = 1.8;
formSwitchSide = 12.7;
formShortSwitchSide = 7;
distanceBetweenButtons = 4.73333333;
buttonElevation = formInnerZDimension + formWallThickness - formSwitchSide-8;
boxSize = formSwitchSide + formWallThickness;

$fn = 100;
$vpr=[55,0,$t*360];

difference(){
    customEnclosure(formInnerXDimension, formInnerYDimension, formInnerZDimension, formWallThickness, formScrewRadius);
    translate([0,0,buttonElevation]){
        
        translate([formInnerXDimension+formWallThickness,formWallThickness*1.5+formSwitchSide/2,formSwitchSide/2 + formWallThickness*1.5]){
            cube([formSwitchSide/2,formSwitchSide/2,formSwitchSide/2], center = true);
        }
        translate([formInnerXDimension+formWallThickness,(formWallThickness*1.5+formSwitchSide/2)+(formSwitchSide+distanceBetweenButtons+formWallThickness*1.5),formSwitchSide/2 + formWallThickness*1.5]){
            cube([formSwitchSide/2,formSwitchSide/2,formSwitchSide/2], center = true);
        }
        translate([formInnerXDimension+formWallThickness,(formWallThickness*1.5+formSwitchSide/2)+(formSwitchSide+distanceBetweenButtons+formWallThickness*1.5)*2,formSwitchSide/2 + formWallThickness*1.5]){
            cube([formSwitchSide/2,formSwitchSide/2,formSwitchSide/2], center = true);
        }
        translate([formInnerXDimension+formWallThickness,(formWallThickness*1.5+formSwitchSide/2)+(formSwitchSide+distanceBetweenButtons+formWallThickness*1.5)*3,formSwitchSide/2 + formWallThickness*1.5]){
            cube([formSwitchSide/2,formSwitchSide/2,formSwitchSide/2], center = true);
        }
    }
    translate([0,formWallThickness+formSwitchSide*1.5,buttonElevation+formSwitchSide/2 + formWallThickness*1.5]){
        cube([formSwitchSide/2,formSwitchSide*2.5,formSwitchSide/2], center = true);
    }
}

translate([formInnerXDimension + formWallThickness*2+formSwitchSide/2,formSwitchSide/2+formWallThickness*1.5,0]){
    translate([0,formSwitchSide*3+formWallThickness*4.5+distanceBetweenButtons*3,0]){
        fingerButtonSocket(formWallThickness, formSwitchSide, formShortSwitchSide);
    }
    translate([0,formSwitchSide*2+formWallThickness*3+distanceBetweenButtons*2,0]){
        fingerButtonSocket(formWallThickness, formSwitchSide, formShortSwitchSide);
    }
    translate([0,formSwitchSide+formWallThickness*1.5+distanceBetweenButtons,0]){
        fingerButtonSocket(formWallThickness, formSwitchSide, formShortSwitchSide);
    }
    translate([0,0,0]){
        fingerButtonSocket(formWallThickness, formSwitchSide, formShortSwitchSide);
    }
}

translate([-formWallThickness*3,(formWallThickness*2+formSwitchSide*3)/2,(formSwitchSide + formWallThickness)/2+buttonElevation]){
    difference(){
        cube([formSwitchSide+formWallThickness,formWallThickness*2+formSwitchSide*3, formSwitchSide+formWallThickness], center = true);
        translate([0,0,formWallThickness]){
            cube([formSwitchSide+formWallThickness+0.001,formWallThickness*0+formSwitchSide*3, formSwitchSide+formWallThickness], center = true);
        }
    }
}

module thumbButtonSocket(wallThickness, switchSide, shortSwitchSide){
    boxSize = switchSide + wallThickness;
    translate([-wallThickness,0,(switchSide + wallThickness)/2+buttonElevation]){
        difference(){
            cube([switchSide,boxSize+wallThickness*2,boxSize], center = true);
            translate([wallThickness,0,wallThickness]){
                cube([switchSide+0.01,switchSide+0.01,switchSide+0.01], center = true);
            }
            translate([shortSwitchSide*1.5,0,wallThickness*1.5]){
                cube([boxSize,boxSize*2,boxSize], center = true);
            }
            translate([-boxSize/2+wallThickness,0,wallThickness]){
                cube([switchSide/2,switchSide/2,switchSide/2], center = true);
            }
        }
    }
}

module fingerButtonSocket(wallThickness, switchSide, shortSwitchSide){
    boxSize = switchSide + wallThickness;
    translate([-wallThickness,0,(switchSide + wallThickness)/2+buttonElevation]){
        difference(){
            cube([switchSide,boxSize+wallThickness*2,boxSize], center = true);
            translate([wallThickness,0,wallThickness]){
                cube([switchSide+0.01,switchSide+0.01,switchSide+0.01], center = true);
            }
            translate([shortSwitchSide*1.5,0,wallThickness*1.5]){
                cube([boxSize,boxSize*2,boxSize], center = true);
            }
            translate([-boxSize/2+wallThickness,0,wallThickness]){
                cube([switchSide/2,switchSide/2,switchSide/2], center = true);
            }
        }
    }
}

module customEnclosure(innerXDimension,innerYDimension,innerZDimension,wallThickness, screwRadius){
    difference (){
        shell(innerXDimension,innerYDimension,innerZDimension,wallThickness);
        translate([(innerXDimension)/2+wallThickness,(innerYDimension)/2+wallThickness,(innerZDimension)/2+wallThickness*3]){
            innards(innerXDimension,innerYDimension,innerZDimension,wallThickness);
        }
    }
    translate([innerXDimension/2+wallThickness,innerYDimension*2+wallThickness*3,wallThickness/2]){
        difference(){
            lid(innerXDimension,innerYDimension,wallThickness);
            countersunkHolePattern(innerXDimension,innerYDimension,wallThickness, screwRadius+0.2);
        }
    }
    translate([innerXDimension/2+wallThickness,innerYDimension/2+wallThickness,innerZDimension/1+wallThickness*1.5]){
        difference(){
            intersection(){
                lidShelves(innerXDimension,innerYDimension,innerZDimension,wallThickness, screwRadius);
                translate([0,0,-innerZDimension/2 - wallThickness*2]){
                    innards(innerXDimension,innerYDimension,innerZDimension,wallThickness);
                }
            }
            lid(innerXDimension,innerYDimension,wallThickness);
            holePattern(innerXDimension,innerYDimension,wallThickness, screwRadius);
        }
    }
}

module countersunkHolePattern(innerXDimension,innerYDimension,wallThickness, screwRadius){
    xTranslation = innerXDimension/2-wallThickness - screwRadius;
    yTranslation = innerYDimension/2-wallThickness - screwRadius;
    translate([xTranslation,yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
        cylinder(wallThickness+.001, screwRadius, screwRadius*2, center = true);
    }
    translate([-xTranslation,-yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
        cylinder(wallThickness+.001, screwRadius, screwRadius*2, center = true);
    }
    translate([-xTranslation,yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
        cylinder(wallThickness+.001, screwRadius, screwRadius*2, center = true);
    }
    translate([xTranslation,-yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
        cylinder(wallThickness+.001, screwRadius, screwRadius*2, center = true);
    }
}

module lidShelves(innerXDimension,innerYDimension,innerZDimension,wallThickness, screwRadius){
    xTranslation = innerXDimension/2-wallThickness*.5;
    yTranslation = innerYDimension/2-wallThickness*.5;
    zTranslation = -wallThickness;
    sphereSize = (4*screwRadius + wallThickness);
    translate([xTranslation,yTranslation,zTranslation]){
        sphere(sphereSize);
    }
    translate([-xTranslation,-yTranslation,zTranslation]){
        sphere(sphereSize);
    }
    translate([-xTranslation,yTranslation,zTranslation]){
        sphere(sphereSize);
    }
    translate([xTranslation,-yTranslation,zTranslation]){
        sphere(sphereSize);
    }
}

module holePattern(innerXDimension,innerYDimension,wallThickness, screwRadius){
    xTranslation = innerXDimension/2-wallThickness - screwRadius;
    yTranslation = innerYDimension/2-wallThickness - screwRadius;
    translate([xTranslation,yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
    }
    translate([-xTranslation,-yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
    }
    translate([-xTranslation,yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
    }
    translate([xTranslation,-yTranslation,0]){
        cylinder(wallThickness*20, screwRadius, screwRadius, center = true);
    }
}

module lid(innerXDimension,innerYDimension,wallThickness){
    cube([innerXDimension+wallThickness*2,innerYDimension+wallThickness*2,wallThickness], center = true);
}

module innards(innerXDimension,innerYDimension,innerZDimension,wallThickness){
    cube([innerXDimension, innerYDimension, innerZDimension+wallThickness*4], center = true);
}

module shell(innerXDimension,innerYDimension,innerZDimension,wallThickness){
    translate([innerXDimension/2+wallThickness,innerYDimension/2+wallThickness,innerZDimension/2+wallThickness]){
        cube([innerXDimension+wallThickness*2, innerYDimension+wallThickness*2, innerZDimension+wallThickness*2], center = true);
    }
}